## rhvoice 1.2.3+dfsg

=== CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 3.5.1)
project("RHVoice")

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake")
include(FindPkgConfig)
include(GNUInstallDirs)
include(CPackComponent)
include(Hardening)
include(VersionFromGit)
getVersionFromGit("RHVOICE" "1.2.2")

if(${CMAKE_VERSION} VERSION_GREATER "3.12") 
	set(CMAKE_CXX_STANDARD 20)
else()
	if(${CMAKE_VERSION} VERSION_GREATER "3.8") 
		set(CMAKE_CXX_STANDARD 17)
	else()
		set(CMAKE_CXX_STANDARD 14)
	endif()
endif()


set(CMAKE_C_STANDARD 11)


macro(pass_through_cpack_vars)
	get_cmake_property(cpackVarsToPassthrough VARIABLES)
	foreach(varName ${cpackVarsToPassthrough})
		if(varName MATCHES "^CPACK_")
			set("${varName}" "${${varName}}" PARENT_SCOPE)
		endif()
	endforeach()
endmacro()

#def create_languages_user_var():
#    names=sorted(os.listdir(Dir("#data").Dir("languages").abspath))
#    langs=[name.lower() for name in names]
#    name_map=dict(zip(names,langs))
#    def_langs=langs
#    if sys.platform!="win32":
#        def_langs=[lang for lang in langs if lang not in["georgian"]]
#    help="Which languages to install"
#    return ListVariable("languages",help,def_langs,langs,name_map)

if(CMAKE_INSTALL_PREFIX EQUAL "/usr")
	set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()


set("dev" OFF CACHE BOOL "The build will only be used for development: no global installation, run from the source directory, compile helper utilities")
set("ENABLE_MAGE" ON CACHE BOOL "Build with MAGE")
set("WITH_DATA" ON CACHE BOOL "Build packages with data. Long to compress. When debugging RHVoice itself it makes sense to disable it.")
#set("spd_version" validate_spd_version CACHE ??? "Speech dispatcher version")
set("release" ON CACHE BOOL "Whether we are building a release")
set("enable_xp_compat" ON CACHE BOOL "Target Windows XP")
set("msi_repo" "" CACHE PATH "Where the msi packages are kept for reuse")
set("servicedir" "${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services" CACHE PATH ".service file installation directory")

set("data_dir" "${CMAKE_INSTALL_FULL_DATADIR}/RHVoice")
set("languages_dir" "${data_dir}/languages")
set("voices_dir" "${data_dir}/voices")

set("config_dir" "${CMAKE_INSTALL_FULL_SYSCONFDIR}/RHVoice")
set("common_doc_dir" "${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc")

set(SubpackagesDir "${CMAKE_CURRENT_SOURCE_DIR}/src")
set("licenses_dir" "${CMAKE_CURRENT_SOURCE_DIR}/licenses")
set("voice_licenses_dir" "${licenses_dir}/voices")

add_subdirectory("${SubpackagesDir}")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/config")
if(WITH_DATA)
	add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/data")
endif()

set(CPACK_PACKAGE_CHECKSUM "SHA512")
set(CPACK_GENERATOR "DEB")
set(CPACK_DEBIAN_COMPRESSION_TYPE "xz")
option(CPACK_RPM_COMPONENT_INSTALL "Split into multiple rpm packages" ON)
option(CPACK_DEB_COMPONENT_INSTALL "Split into multiple deb packages" ON)
set(CPACK_PACKAGE_VENDOR "Olga Yakovleva")
set(CPACK_PACKAGE_CONTACT "https://github.com/Olga-Yakovleva/RHVoice")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://github.com/Olga-Yakovleva/RHVoice")

if(ENABLE_MAGE)
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/licenses/gpl-3.0.txt")
else()
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/licenses/lgpl-2.1.txt")
endif()

set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

set(CPACK_DEBIAN_PACKAGE_NAME "RHVoice")
set(CPACK_PACKAGE_VERSION_MAJOR "${RHVOICE_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${RHVOICE_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${RHVOICE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_TWEAK "${RHVOICE_VERSION_TWEAK}")

set(CPACK_COMPONENTS_GROUPING "IGNORE")

set(CPACK_MONOLITHIC_INSTALL OFF)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CPACK_RESOURCE_FILE_README}")

include(CPack)

=== SConstruct ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018, 2020  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import os.path
import subprocess
import platform
import datetime
import re
if sys.platform=="win32":
    if sys.version_info[0]>=3:
        import winreg
    else:
        import _winreg as winreg

def get_version(is_release):
    next_version="1.2.3"
    return next_version

def CheckPKGConfig(context):
    context.Message("Checking for pkg-config... ")
    result=context.TryAction("pkg-config --version")[0]
    context.Result(result)
    return result

def CheckPKG(context,name):
    context.Message("Checking for {}... ".format(name))
    result=context.TryAction("pkg-config --exists '{}'".format(name))[0]
    context.Result(result)
    return result

def CheckMSVC(context):
    context.Message("Checking for Visual C++ ... ")
    result=0
    version=context.env.get("MSVC_VERSION",None)
    if version is not None:
        result=1
    context.Result(result)
    return result

def CheckXPCompat(context):
    context.Message("Checking for Windows XP compatibility ... ")
    result=0
    if context.env.get("xp_compat_enabled",False):
        result=1
    context.Result(result)
    return result

def CheckNSIS(context):
    result=0
    context.Message("Checking for NSIS")
    key_name=r"SOFTWARE\NSIS"
    try:
        with winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE,key_name,0,winreg.KEY_READ|winreg.KEY_WOW64_32KEY) as key:
                context.env["makensis"]=File(os.path.join(winreg.QueryValueEx(key,None)[0],"makensis.exe"))
                result=1
    except WindowsError:
         pass
    context.Result(result)
    return result

def CheckWiX(context):
    result=0
    context.Message("Checking for WiX toolset")
    if "WIX" in os.environ:
        context.env["WIX"]=os.environ["WIX"]
        result=1
    context.Result(result)
    return result

def validate_spd_version(key,val,env):
    m=re.match(r"^\d+\.\d+",val)
    if m is None:
        raise Exception("Invalid value of spd_version: {}".format(val))

def CheckSpdVersion(ctx):
    ctx.Message("Checking Speech Dispatcher version ... ")
    ver=ctx.env.get("spd_version",None)
    if ver is not None:
        ctx.Result(ver)
        return ver
    res, ver=ctx.TryAction("pkg-config --modversion speech-dispatcher > $TARGET")
    ver=ver.strip()
    if not res:
        src='#include <stdio.h>\n#include <speech-dispatcher/libspeechd_version.h>\nint main() {\nint major=LIBSPEECHD_MAJOR_VERSION;\nint minor=LIBSPEECHD_MINOR_VERSION;\nprintf("%d.%d",major,minor);\nreturn 0;}'
        res,ver=ctx.TryRun(src,".c")
    if not res:
        ctx.Result(res)
        return res
    ctx.env["spd_version"]=ver
    ctx.Result(ver)
    return ver

def convert_flags(value):
    return value.split()

def convert_path(value):
    return value.split(";" if sys.platform=="win32" else ":")

def setup():
    if sys.platform=="win32":
        SetOption("warn","no-visual-c-missing")
    global BUILDDIR,var_cache
    system=platform.system().lower()
    BUILDDIR=os.path.join("build",system)
    var_cache=os.path.join(BUILDDIR,"user.conf")
    Execute(Mkdir(BUILDDIR))
    SConsignFile(os.path.join(BUILDDIR,"scons"))

def create_languages_user_var():
    names=sorted(os.listdir(Dir("#data").Dir("languages").abspath))
    langs=[name.lower() for name in names]
    name_map=dict(zip(names,langs))
    def_langs=langs
    if sys.platform!="win32":
        def_langs=[lang for lang in langs if lang not in["georgian"]]
    help="Which languages to install"
    return ListVariable("languages",help,def_langs,langs,name_map)

def create_audio_libs_user_var():
    libs=["pulse","libao","portaudio"]
    help="Which audio libraries to use if they are available"
    return ListVariable("audio_libs",help,libs,libs)

def create_user_vars():
    args={"DESTDIR":""}
    args.update(ARGUMENTS)
    vars=Variables(var_cache,args)
    vars.Add(BoolVariable("dev","The build will only be used for development: no global installation, run from the source directory, compile helper utilities",False))
    vars.Add(create_languages_user_var())
    vars.Add(BoolVariable("enable_mage","Build with MAGE",True))
    vars.Add(create_audio_libs_user_var())
    vars.Add("spd_version","Speech dispatcher version",validator=validate_spd_version)
    vars.Add(BoolVariable("release","Whether we are building a release",True))
    if sys.platform=="win32":
        vars.Add(BoolVariable("enable_x64","Additionally build 64-bit versions of all the libraries",True))
        vars.Add(BoolVariable("enable_xp_compat","Target Windows XP",True))
        vars.Add(PathVariable("msi_repo","Where the msi packages are kept for reuse",None,PathVariable.PathIsDir))
    else:
        vars.Add("prefix","Installation prefix","/usr/local")
        vars.Add("bindir","Program installation directory","$prefix/bin")
        vars.Add("libdir","Library installation directory","$prefix/lib")
        vars.Add("includedir","Header installation directory","$prefix/include")
        vars.Add("datadir","Data installation directory","$prefix/share")
        vars.Add("sysconfdir","A directory for configuration files","$prefix/etc")
        vars.Add("servicedir",".service file installation directory","$datadir/dbus-1/services")
        vars.Add("DESTDIR","Support for staged installation","")
        vars.Add(BoolVariable("enable_shared","Build a shared library",True))
    if sys.platform=="win32":
        suffixes=["32","64"]
    else:
        suffixes=[""]
    for suffix in suffixes:
        vars.Add("CPPPATH"+suffix,"List of directories where to search for headers",[],converter=convert_path)
        vars.Add("LIBPATH"+suffix,"List of directories where to search for libraries",[],converter=convert_path)
    vars.Add("CPPFLAGS","C/C++ preprocessor flags",[],converter=convert_flags)
    vars.Add("CCFLAGS","C/C++ compiler flags",["/O2","/GL","/Gw"] if sys.platform=="win32" else ["-O2"],converter=convert_flags)
    vars.Add("CFLAGS","C compiler flags",[],converter=convert_flags)
    vars.Add("CXXFLAGS","C++ compiler flags",[],converter=convert_flags)
    vars.Add("LINKFLAGS","Linker flags",["/LTCG","/OPT:REF","/OPT:ICF"] if sys.platform=="win32" else [],converter=convert_flags)
    return vars

def create_base_env(user_vars):
    env_args={"variables":user_vars}
    if sys.platform=="win32":
        env_args["tools"]=["newlines"]
    else:
        env_args["tools"]=["default","installer"]
    env_args["tools"].extend(["textfile","library"])
    env_args["LIBS"]=[]
    env_args["package_name"]="RHVoice"
    env_args["CPPDEFINES"]=[("RHVOICE","1")]
    env=Environment(**env_args)
    if env["dev"]:
        env["prefix"]=os.path.abspath("local")
        env["RPATH"]=env.Dir("$libdir").abspath
    env["package_version"]=get_version(env["release"])
    env.Append(CPPDEFINES=("PACKAGE",env.subst(r'\"$package_name\"')))
    if env["PLATFORM"]=="win32":
        env.Append(CPPDEFINES=("WIN32",1))
        env.Append(CPPDEFINES=("UNICODE",1))
        env.Append(CPPDEFINES=("NOMINMAX",1))
    env["libcore"]="RHVoice_core"
    env["libaudio"]="RHVoice_audio"
    return env

def display_help(env,vars):
    Help("Type 'scons' to build the package.\n")
    if sys.platform!="win32":
        Help("Then type 'scons install' to install it.\n")
        Help("Type 'scons --clean install' to uninstall the software.\n")
    Help("You may use the following configuration variables:\n")
    Help(vars.GenerateHelpText(env))

def clone_base_env(base_env,user_vars,arch=None):
    args={}
    if sys.platform=="win32":
        if arch is not None:
            args["TARGET_ARCH"]=arch
        args["tools"]=["msvc","mslink","mslib"]
    env=base_env.Clone(**args)
    user_vars.Update(env)
    if env["PLATFORM"]=="win32":
        env.AppendUnique(CCFLAGS=["/nologo","/MT"])
        env.AppendUnique(LINKFLAGS=["/nologo"])
        env.AppendUnique(CXXFLAGS=["/EHsc"])
        if env["enable_xp_compat"]:
            env.Tool("xp_compat")
    if "gcc" in env["TOOLS"]:
        env.MergeFlags("-pthread")
        env.AppendUnique(CXXFLAGS=["-std=c++11"])
        env.AppendUnique(CFLAGS=["-std=c99"])
    if sys.platform=="win32":
        bits="64" if arch.endswith("64") else "32"
        env["BUILDDIR"]=os.path.join(BUILDDIR,arch)
        env["CPPPATH"]=env["CPPPATH"+bits]
        env["LIBPATH"]=env["LIBPATH"+bits]
    else:
        env["BUILDDIR"]=BUILDDIR
    third_party_dir=os.path.join("src","third-party")
    for path in Glob(os.path.join(third_party_dir,"*"),strings=True):
        if os.path.isdir(path):
            env.Prepend(CPPPATH=("#"+path))
    env.Prepend(CPPPATH=(os.path.join("#"+env["BUILDDIR"],"include"),".",os.path.join("#src","include")))
    return env

def configure(env):
    tests={"CheckPKGConfig":CheckPKGConfig,"CheckPKG":CheckPKG,"CheckSpdVersion":CheckSpdVersion}
    if env["PLATFORM"]=="win32":
        tests["CheckMSVC"]=CheckMSVC
        tests["CheckXPCompat"]=CheckXPCompat
    conf=env.Configure(conf_dir=os.path.join(env["BUILDDIR"],"configure_tests"),
                       log_file=os.path.join(env["BUILDDIR"],"configure.log"),
                       config_h=os.path.join(env["BUILDDIR"],"include","configure.h"),
                       custom_tests=tests)
    if env["PLATFORM"]=="win32":
        if not conf.CheckMSVC():
            print("Error: Visual C++ is not installed")
            exit(1)
        print("Visual C++ version is {}".format(env["MSVC_VERSION"]))
        if env["enable_xp_compat"] and not conf.CheckXPCompat():
            print("Error: Windows XP compatibility cannot be enabled")
            exit(1)
    if not conf.CheckCC():
        print("The C compiler is not working")
        exit(1)
    if not conf.CheckCXX():
        print("The C++ compiler is not working")
        exit(1)
# has_sox=conf.CheckLibWithHeader("sox","sox.h","C",call='sox_init();',autoadd=0)
# if not has_sox:
#     print("Error: cannot link with libsox")
#     exit(1)
# env.PrependUnique(LIBS="sox")
    has_giomm=False
    has_pkg_config=conf.CheckPKGConfig()
    if has_pkg_config:
        if "pulse" in env["audio_libs"] and not conf.CheckPKG("libpulse-simple"):
            env["audio_libs"].remove("pulse")
        if "libao" in env["audio_libs"] and not conf.CheckPKG("ao"):
            env["audio_libs"].remove("libao")
        if "portaudio" in env["audio_libs"] and not conf.CheckPKG("portaudio-2.0"):
            env["audio_libs"].remove("portaudio")
        if env["audio_libs"]:
            conf.CheckSpdVersion()
    else:
        env["audio_libs"]=[]
#        has_giomm=conf.CheckPKG("giomm-2.4")
    if env["PLATFORM"]=="win32":
        env.AppendUnique(LIBS="kernel32")
    conf.Finish()
    env.Prepend(LIBPATH=os.path.join("#"+env["BUILDDIR"],"core"))
    src_subdirs=["third-party","core","lib"]
    if env["dev"]:
        src_subdirs.append("utils")
    src_subdirs.append("audio")
    src_subdirs.append("test")
    if env["audio_libs"]:
        src_subdirs.append("sd_module")
    env.Prepend(LIBPATH=os.path.join("#"+env["BUILDDIR"],"audio"))
    if has_giomm:
        src_subdirs.append("service")
    if env["PLATFORM"]=="win32":
        src_subdirs.append("sapi")
    else:
        src_subdirs.append("include")
    return src_subdirs

def build_binaries(base_env,user_vars,arch=None):

=== config/CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/RHVoice.conf"
	DESTINATION "${config_dir}"
	COMPONENT "core"
)

=== data/CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2012, 2013, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
cpack_add_component_group("data")


set("ISO639_1_NAME2CODE_Russian" "ru")
set("ISO639_1_NAME2CODE_English" "en")
set("ISO639_1_NAME2CODE_Ukrainian" "uk")
set("ISO639_1_NAME2CODE_Brazilian" "br")
set("ISO639_1_NAME2CODE_Portuguese" "pt")
set("ISO639_1_NAME2CODE_Brazilian-Portuguese" "${ISO639_1_NAME2CODE_Portuguese}-BR")

set("ISO639_1_NAME2CODE_Esperanto" "eo")
set("ISO639_1_NAME2CODE_Georgian" "ka")
set("ISO639_1_NAME2CODE_Kyrgyz" "ky")
set("ISO639_1_NAME2CODE_Tatar" "tt")


set("VOICE_talgat_LICENSE" "Proprietary, non-commercial") # Tatar
set("VOICE_natia_LICENSE" "Proprietary, personal use only") # Georgian
set("VOICE_Leticia-F123_LICENSE" "by-sa-4.0") # Brazilian Portuguese

set("VOICE_aleksandr_LANG" "ru")
set("VOICE_anna_LANG" "ru")
set("VOICE_elena_LANG" "ru")
set("VOICE_irina_LANG" "ru")
set("VOICE_artemiy_LANG" "ru")

set("VOICE_alan_LANG" "en")
set("VOICE_bdl_LANG" "en")
set("VOICE_clb_LANG" "en")
set("VOICE_slt_LANG" "en")

set("VOICE_anatol_LANG" "uk")
set("VOICE_natalia_LANG" "uk")

set("VOICE_Leticia-F123_LANG" "${ISO639_1_NAME2CODE_Brazilian-Portuguese}")

set("VOICE_spomenka_LANG" "eo")

set("VOICE_natia_LANG" "ka")

set("VOICE_azamat_LANG" "ky")
set("VOICE_nazgul_LANG" "ky")

set("VOICE_talgat_LANG" "tt")

add_subdirectory("languages")
add_subdirectory("voices")
pass_through_cpack_vars()

=== src/CMakeLists.txt ===
set(INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
configure_file("${INCLUDE_DIR}/core/config.h.in" "${INCLUDE_DIR}/core/config.h")

add_subdirectory("third-party")
set(HTS_LABELS_KIT_INCLUDES "${UTF8_INCLUDE_DIR}" "${RAPIDXML_INCLUDE_DIR}")

add_subdirectory("core")
add_subdirectory("audio")
add_subdirectory("lib")
add_subdirectory("bin")
add_subdirectory("utils")
add_subdirectory("test")

IF (WIN32)
	#add_subdirectory("sapi")
	#add_subdirectory("nvda-synthDriver")
	#add_subdirectory("wininst")
else()
	add_subdirectory("service")
	add_subdirectory("sd_module")
endif()

pass_through_cpack_vars()

=== data/languages/CMakeLists.txt ===
set("CPACK_DEBIAN_LANGUAGES_PACKAGE_NAME" "rhvoice-languages" PARENT_SCOPE)

macro(languageInDir languageName langDir)
	set(lang_var_name "ISO639_1_NAME2CODE_${languageName}")

	if(${lang_var_name})
		set(langCode "${${lang_var_name}}")
	else()
		message(FATAL_ERROR "Please set ${lang_var_name} to the code of the lang from https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes")
	endif()

	set(languagePackageName "RHVoice-language-${langCode}")
	file(GLOB_RECURSE SRCFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${langDir}/*")
	add_custom_target(
		"${languagePackageName}"
		SOURCES "${SRCFILES}"
	)

	string(TOUPPER "${languagePackageName}" languagePackageNameUpper)
	cpack_add_component("${languagePackageName}" GROUP "languages" DISPLAY_NAME "${languageName}"
		DESCRIPTION "${languageName} language (${langCode}) for RHVoice"
	)

	set("CPACK_DEBIAN_${languagePackageNameUpper}_PACKAGE_NAME" "${languagePackageName}")
	set("CPACK_RPM_${languagePackageNameUpper}_PACKAGE_NAME" "${languagePackageName}")
	set("CPACK_DEBIAN_${languagePackageNameUpper}_PACKAGE_DEPENDS" "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, RHVoice-language-${langCode}" PARENT_SCOPE)
	set("CPACK_DEBIAN_${languagePackageNameUpper}_PACKAGE_SECTION" "contrib" PARENT_SCOPE)

	install(DIRECTORY "${langDir}"
		DESTINATION "${languages_dir}"
		COMPONENT "${languagePackageName}"
		PATTERN "SConscript" EXCLUDE
		PATTERN "CMakeLists.txt" EXCLUDE
	)
	pass_through_cpack_vars()
endmacro()


#set("CPACK_DEBIAN_LANGUAGES_PACKAGE_NAME" "rhvoice-languages" PARENT_SCOPE)

cpack_add_component_group("languages"
	DISPLAY_NAME "Languages"
	DESCRIPTION "Different languages"
	PARENT_GROUP "data"
	EXPANDED
)

file(GLOB languagesDirzInThisDir
	LIST_DIRECTORIES true
	"${CMAKE_CURRENT_SOURCE_DIR}/*"
)
foreach(langDir IN LISTS languagesDirzInThisDir)
	if(IS_DIRECTORY "${langDir}")
		get_filename_component(languageName "${langDir}" NAME)
		if(EXISTS "${langDir}/CMakeLists.txt")
			add_subdirectory("${langDir}")
		else()
			languageInDir("${languageName}" "${langDir}" )
		endif()
	endif()
endforeach()

pass_through_cpack_vars()

=== data/voices/CMakeLists.txt ===
set("CPACK_DEBIAN_VOICES_PACKAGE_NAME" "rhvoice-voices" PARENT_SCOPE)

macro(voiceInDir voiceName voiceDir)
	set(lang_var_name "VOICE_${voiceName}_LANG")
	set(lang_license_name "VOICE_${voiceName}_LICENSE")

	if(${lang_var_name})
		set(langCode "${${lang_var_name}}")
	else()
		message(FATAL_ERROR "Please set ${lang_var_name} to the code of the lang of the voice ${voiceName} from https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes")
	endif()

	if(${lang_license_name})
		set(license "${${lang_license_name}}")
	else()
		set(license "lgpl-2.1")
	endif()

	set(voicePackageName "RHVoice-voice-${langCode}-${voiceName}")
	file(GLOB_RECURSE SRCFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${voiceDir}/*")
	add_custom_target(
		"${voicePackageName}"
		SOURCES "${SRCFILES}"
	)

	string(TOUPPER "${voicePackageName}" voicePackageNameUpper)
	cpack_add_component("${voicePackageName}" GROUP "voices" DISPLAY_NAME "${voiceName}"
		DESCRIPTION "${voiceName} voice for ${langCode} language for RHVoice licensed under `${license}` license."
	)

	set("CPACK_DEBIAN_${voicePackageNameUpper}_PACKAGE_NAME" "${voicePackageName}")
	set("CPACK_RPM_${voicePackageNameUpper}_PACKAGE_NAME" "${voicePackageName}")
	set("CPACK_DEBIAN_${voicePackageNameUpper}_PACKAGE_DEPENDS" "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, RHVoice-language-${langCode}" PARENT_SCOPE)
	set("CPACK_DEBIAN_${languagePackageNameUpper}_PACKAGE_SECTION" "contrib" PARENT_SCOPE)
	
	install(DIRECTORY "${voiceDir}"
		DESTINATION "${voices_dir}"
		COMPONENT "${voicePackageName}"
		PATTERN "SConscript" EXCLUDE
		PATTERN "CMakeLists.txt" EXCLUDE
	)

	set(licenseFileCandidate "${licenses_dir}/${license}.txt")
	if(EXISTS "${licenseFileCandidate}")
		install(FILES "${licenseFileCandidate}"
			DESTINATION "${common_doc_dir}/${voiceName}/"
			COMPONENT "${voicePackageName}"
			RENAME "copyright"
		)
	else()
		set(licenseDirCandidate "${voice_licenses_dir}/${voiceName}")
		if(EXISTS "${licenseDirCandidate}")
			file(GLOB_RECURSE licenseFiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${licenseDirCandidate}/*")
			list(LENGTH "${licenseFiles}" licenseFilesLen)
			if(licenseFilesLen EQUAL "1")
				install(FILES ${licenseFiles}
					DESTINATION "${common_doc_dir}/${voiceName}/"
					COMPONENT "${voicePackageName}"
					RENAME "copyright"
				)
			else()
				install(FILES ${licenseFiles}
					DESTINATION "${common_doc_dir}/${voiceName}/"
					COMPONENT "${voicePackageName}"
				)
			endif()
		else()
			message(FATAL_ERROR "License files are missing for the voice ${voiceName}!")
		endif()
	endif()

	pass_through_cpack_vars()
endmacro()


#set("CPACK_DEBIAN_VOICES_PACKAGE_NAME" "rhvoice-voices" PARENT_SCOPE)

cpack_add_component_group("voices"
	DISPLAY_NAME "Voices"
	DESCRIPTION "Different voices"
	PARENT_GROUP "data"
	EXPANDED
)

file(GLOB voicesDirzInThisDir
	LIST_DIRECTORIES true
	"${CMAKE_CURRENT_SOURCE_DIR}/*"
)
foreach(voiceDir IN LISTS voicesDirzInThisDir)
	if(IS_DIRECTORY "${voiceDir}")
		get_filename_component(voiceName "${voiceDir}" NAME)
		if(EXISTS "${voiceDir}/CMakeLists.txt")
			add_subdirectory("${voiceDir}")
		else()
			voiceInDir("${voiceName}" "${voiceDir}" )
		endif()
	endif()
endforeach()

pass_through_cpack_vars()

=== src/audio/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(SOURCES "audio.cpp;file_playback_stream_impl.cpp;playback_stream.cpp")

set(audio_libs "libao;pulse;portaudio")

pkg_check_modules(LIBAO "ao")
pkg_check_modules(LIBPORTAUDIO "portaudio-2.0")
pkg_check_modules(LIBPULSESIMPLE "libpulse-simple")
option(WITH_LIBAO "Support libao" "${LIBAO_FOUND}")
option(WITH_PULSE "Support pulseaudio" "${LIBPULSESIMPLE_FOUND}")
option(WITH_PORTAUDIO "Support portaudio" "${LIBPORTAUDIO_FOUND}")

if(WITH_LIBAO)
	list(APPEND SOURCES "libao.cpp")
endif()
if(WITH_PULSE)
	list(APPEND SOURCES "pulse.cpp")
endif()
if(WITH_PORTAUDIO)
	list(APPEND SOURCES "portaudio.cpp")
endif()

add_library(RHVoice_audio SHARED "${SOURCES}")
set_target_properties(RHVoice_audio PROPERTIES VERSION "${RHVOICE_VERSION}" SOVERSION "${RHVOICE_VERSION_MAJOR}")
harden("RHVoice_audio")
target_include_directories(RHVoice_audio PRIVATE "${INCLUDE_DIR}")

if(WITH_LIBAO)
	target_link_libraries(RHVoice_audio "${LIBAO_LIBRARIES}")
	message(STATUS "${LIBAO_INCLUDE_DIRS}")
	target_include_directories(RHVoice_audio PRIVATE "${LIBAO_INCLUDE_DIRS}")
endif()
if(WITH_PULSE)
	target_compile_definitions(RHVoice_audio PUBLIC WITH_PULSE)
	target_link_libraries(RHVoice_audio "${LIBPULSESIMPLE_LIBRARIES}")
	target_include_directories(RHVoice_audio PRIVATE "${LIBPULSESIMPLE_INCLUDE_DIRS}")
endif()
if(WITH_PORTAUDIO)
	target_compile_definitions(RHVoice_audio PUBLIC WITH_PORTAUDIO)
	target_link_libraries(RHVoice_audio "${LIBPORTAUDIO_LIBRARIES}")
	target_include_directories(RHVoice_audio PRIVATE "${LIBPORTAUDIO_INCLUDE_DIRS}")
endif()

install(TARGETS "RHVoice_audio"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	COMPONENT "audio"
)

set("CPACK_DEBIAN_AUDIO_PACKAGE_NAME" "librhvoice-audio" PARENT_SCOPE)
set(CPACK_DEBIAN_AUDIO_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}" PARENT_SCOPE)

=== src/bin/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2014, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_executable("RHVoice-client" "${CMAKE_CURRENT_SOURCE_DIR}/rhvoice-client.c")
target_link_libraries("RHVoice-client" "RHVoice_core")
harden("RHVoice-client")
target_compile_definitions("RHVoice-client" PRIVATE "-DVERSION=\"${VERSION}\"")

#add_executable("RHVoice" "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")
#target_link_libraries("RHVoice" "RHVoice_core")
#target_compile_definitions(RHVoice PRIVATE "-DPACKAGE=\"RHVoice\"")
#harden("RHVoice")

install(TARGETS "RHVoice-client"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	COMPONENT "client"
)

set("CPACK_DEBIAN_CLIENT_PACKAGE_NAME" "rhvoice-client" PARENT_SCOPE)
set(CPACK_DEBIAN_CLIENT_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, ${CPACK_DEBIAN_AUDIO_PACKAGE_NAME}" PARENT_SCOPE)

=== src/core/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2018, 2019  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


file(GLOB_RECURSE SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c" "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp")

# database files, included into needed places
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/emoji_data.cpp")
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/unidata.cpp")
list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/userdict_parser.c")


if(ENABLE_MAGE)
	set(CPACK_DEBIAN_AUDIO_PACKAGE_DEPENDS "${CPACK_DEBIAN_LIBMAGE_PACKAGE_NAME}" PARENT_SCOPE)
else()
	list(REMOVE_ITEM SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/mage_hts_engine_impl.cpp")
endif()

add_library(RHVoice_core SHARED "${SRCFILES}")
set_target_properties(RHVoice_core PROPERTIES VERSION "${RHVOICE_VERSION}" SOVERSION "${RHVOICE_VERSION_MAJOR}")
set(libs2link "sonic" "libhts_engine")
target_include_directories(RHVoice_core PUBLIC "${INCLUDE_DIR}" PRIVATE "${HTS_LABELS_KIT_INCLUDES}")

set(package_name "RHVoice_core")

if(WIN32)
	set("DATA_PATH" "data")
	set("CONFIG_PATH" "config")
else()
	set(DATA_PATH "${data_dir}")
	set(CONFIG_PATH "${config_dir}")
endif()

set(VERSION "${RHVOICE_VERSION}")

if(ENABLE_MAGE)
	list(APPEND libs2link "libmage")
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/config.h")

target_link_libraries(RHVoice_core "${libs2link}")
harden("RHVoice_core")

install(TARGETS "RHVoice_core"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	COMPONENT "core"
)

set("CPACK_DEBIAN_CORE_PACKAGE_NAME" "librhvoice-core" PARENT_SCOPE)

=== src/lib/CMakeLists.txt ===
# Copyright (C) 2010, 2011, 2018, 2019  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_library(RHVoice SHARED "${CMAKE_CURRENT_SOURCE_DIR}/lib.cpp")
set_target_properties(RHVoice PROPERTIES VERSION "${RHVOICE_VERSION}" SOVERSION "${RHVOICE_VERSION_MAJOR}")
harden("RHVoice")
target_include_directories(RHVoice PRIVATE "${INCLUDE_DIR}" "${HTS_LABELS_KIT_INCLUDES}")
target_link_libraries("RHVoice" "RHVoice_core")

install(TARGETS "RHVoice"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	COMPONENT "lib"
)

set("CPACK_DEBIAN_LIB_PACKAGE_NAME" "librhvoice" PARENT_SCOPE)
set(CPACK_DEBIAN_LIB_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, ${CPACK_DEBIAN_AUDIO_PACKAGE_NAME}"  PARENT_SCOPE)

=== src/sd_module/CMakeLists.txt ===
# -*- mode: Python; indent-tabs-mode: t; tab-width: 4 -*-
# Copyright (C) 2012, 2018  Olga Yakovleva <yakovleva.o.v@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB_RECURSE SRCFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c" "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp")
add_executable(sd_rhvoice "${SRCFILES}")
target_include_directories(sd_rhvoice PRIVATE "${INCLUDE_DIR}" "${HTS_LABELS_KIT_INCLUDES}")
target_link_libraries(sd_rhvoice "RHVoice_core" "RHVoice_audio" pthread)
harden(sd_rhvoice)

set(SPEECH_DISPATCHER_MODULES_DIR "${CMAKE_INSTALL_PREFIX}/lib/speech-dispatcher-modules")

install(TARGETS "sd_rhvoice"
	RUNTIME DESTINATION "${SPEECH_DISPATCHER_MODULES_DIR}"
	COMPONENT "sd_module"
)

set("CPACK_DEBIAN_SD_MODULE_PACKAGE_NAME" "speech-dispatcher-rhvoice" PARENT_SCOPE)
set(CPACK_DEBIAN_SD_MODULE_PACKAGE_DEPENDS "${CPACK_DEBIAN_CORE_PACKAGE_NAME}, speech-dispatcher" PARENT_SCOPE)
set(CPACK_DEBIAN_SD_MODULE_PACKAGE_SUGGESTS "spd-say, python3-speechd" PARENT_SCOPE)

=== debian/changelog ===
rhvoice (1.2.3+dfsg-3) unstable; urgency=medium

  * source/lintian-overrides: Update override message.
  * copyright: Fix file paths.
  * watch: Mangle version to +dfsg.
  * control: Bump Standards-Version to 4.6.0 (no change)
  * Continue playing cat and mice again with lintian warning suppression.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 29 Jan 2022 14:51:30 +0100

rhvoice (1.2.3+dfsg-2) unstable; urgency=medium

  * docs: Add missing docs.
  * control: Make librhvoice-core4 depend on a voice rather than librhvoice5.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Oct 2021 13:34:19 +0200

rhvoice (1.2.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: 802852)

 -- Samuel Thibault <sthibault@debian.org>  Wed, 21 Apr 2021 16:05:12 +0200

=== debian/control ===
Source: rhvoice
Section: non-free/sound
Priority: optional
Maintainer: Debian TTS Team <tts-project@alioth-lists.debian.net>
Uploaders: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 13),
 scons,
 libglibmm-2.4-dev,
 portaudio19-dev,
 libpulse-dev,
 libao-dev,
# libhtsengine-dev,
# TODO: libmage-dev,
 librapidxml-dev,
 libsonic-dev,
 libtclap-dev,
 libutfcpp-dev,
Standards-Version: 4.6.0
Homepage: https://github.com/Olga-Yakovleva/RHVoice
Vcs-Browser: https://salsa.debian.org/tts-team/rhvoice
Vcs-Git: https://salsa.debian.org/tts-team/rhvoice.git
Rules-Requires-Root: no
XS-Autobuild: yes

Package: rhvoice
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Speech synthesizer - test tools
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains test tools

Package: speech-dispatcher-rhvoice
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, speech-dispatcher
Description: RHVoice speech synthesizer - speech dispatcher module
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the speech dispatcher module to use RHVoice

Package: rhvoice-russian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Russian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Russian voice

Package: rhvoice-kyrgyz
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Kyrgyz voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Kyrgyz voice

# Note: this voice (Talgat) is really non-free by licence
Package: rhvoice-tatar
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Tatar voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Tatar voice

Package: rhvoice-brazilian-portuguese
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Brazilian Portuguese voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Brazilian Portuguese voice

Package: rhvoice-ukrainian
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Ukrainian voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Ukrainian voice

Package: rhvoice-esperanto
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - Esperanto voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the Esperanto voice

Package: rhvoice-english
Section: non-free/sound
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: rhvoice-voice
Description: RHVoice speech synthesizer - English voice
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 This package provides the English voice

Package: librhvoice-dev
Section: non-free/libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 librhvoice5 (= ${binary:Version}),
 librhvoice-core4 (= ${binary:Version}),
 librhvoice-audio2 (= ${binary:Version}),
Description: RHVoice speech synthesizer - development files
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the development files.

Package: librhvoice5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RHVoice speech synthesizer - shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the shared library

Package: librhvoice-core4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, rhvoice-english | rhvoice-voice
Description: RHVoice speech synthesizer - core shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the core shared library

Package: librhvoice-audio2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RHVoice speech synthesizer - audio shared library
 RHVoice uses statistical parametric synthesis. It relies on existing open
 source speech technologies (mainly HTS and related software).
 .
 Voices are built from recordings of natural speech. They have small footprints,
 because only statistical models are stored on users' computers. And though
 the voices lack the naturalness of the synthesizers which generate speech
 by combining segments of the recordings themselves, they are still very
 intelligible and resemble the speakers who recorded the source material.
 .
 Initially, RHVoice could speak only Russian. Now it also supports English,
 Esperanto and Georgian. In theory, it is possible to implement support for
 other languages, if all the necessary resources can be found or created.
 .
 This package contains the audio shared library

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

SCONS=scons

%:
	dh $@

override_dh_auto_configure:
	:

override_dh_auto_build:
	$(SCONS) prefix="/usr" sysconfdir="/etc" libdir="/usr/lib/$(DEB_HOST_MULTIARCH)" \
		CPPFLAGS="$(CPPFLAGS)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		CXX="$(CXX)" \
		CXXFLAGS="$(CXXFLAGS)" \
		LINKFLAGS="$(LDFLAGS)"

override_dh_auto_clean:
	dh_auto_clean
	$(SCONS) -c
	rm -fr $(CURDIR)/build
	py3clean .

override_dh_auto_install:
	scons DESTDIR=$(CURDIR)/debian/tmp install

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+dfsg$//,\
filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%rhvoice-$1% \
  https://github.com/RHVoice/RHVoice/releases \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## rhvoice 1.8.0%2Bdfsg

=== debian/changelog ===
rhvoice (1.8.0+dfsg-5) unstable; urgency=medium

  * patches/utf8: Fix build against newer libutfcpp-dev (Closes: Bug#1090291)

 -- Samuel Thibault <sthibault@debian.org>  Wed, 29 Jan 2025 23:16:13 +0100

rhvoice (1.8.0+dfsg-4) unstable; urgency=medium

  * control: Drop language list, now outdated (Closes: Bug#1034540)
  * patches/third-party: Don't refer to boost's SConscript
    (Closes: Bug#1084504)

 -- Samuel Thibault <sthibault@debian.org>  Tue, 08 Oct 2024 00:09:42 +0200

rhvoice (1.8.0+dfsg-3) unstable; urgency=medium

  * watch: Use tags instead of releases.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 23 Oct 2022 12:32:57 +0200

rhvoice (1.8.0+dfsg-2) unstable; urgency=medium

  * control: Make librhvoice-core7 conflict+replace librhvoice-core4 for
    /etc/RHVoice/RHVoice.conf.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 25 Jul 2022 19:38:08 +0200

rhvoice (1.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - New rhvoice-albanian, rhvoice-macedonian, rhvoice-polish packages.
    - Rename librhvoice-core4 to librhvoice-core7 according to soname bump.
    - rhvoice-english.install: Add evgeniy-eng and lyubov voices.
    - rhvoice-russian.install: Add aleksandr, aleksandr-hq, arina,
      evgeniy-rus, mikhail, pavel, tatiana, victoria, vitaliy, yuriy voices.
    - rhvoice-ukrainian.install: Add marianna and volodymyr voices.
    - speech-dispatcher-rhvoice.install: Update sd_rhvoice path
    - control: Add libboost-dev and libspeechd-dev build-deps.
    - docs: Drop NEWS.
    - patches/third-party: refresh.
    - control: Update to 1.8.0 upstream release.
    - rules: Enable sonic.
    - copyright: Update.
  * copyright:
    - Add non-free Disclaimer field
    - Add CC-BY-NC-ND-4.0 and CC-BY-SA-4.0 licenses texts.
    - Fix cmake license from Public Domain to Unlicense
    - Drop unused LGPL-2+ license.
    - Closes: Bug#1014459.
  * gbp.conf: Move import-orig filter to copyright's Files-Excluded.
  * watch: Add +dfsg repacksuffix.
  * source/lintian-overrides: Drop now-fixed override.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 24 Jul 2022 23:19:07 +0200
